﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Reflection;
using System.Diagnostics;
using System.IO;

namespace NAntMenu.ShellContextMenu
{
    /// <summary>
    /// Interaction logic for AboutDialog.xaml
    /// </summary>
    public partial class AboutDialog : Window
    {
        public AboutDialog()
        {
            InitializeComponent();
            this.Loaded += new RoutedEventHandler(AboutDialog_Loaded);
        }

        void AboutDialog_Loaded(object sender, RoutedEventArgs e)
        {
            Assembly assembly = Assembly.GetExecutingAssembly();
            string dllFilePath = assembly.Location;

            string appPath = System.IO.Path.GetDirectoryName(dllFilePath);

            FileVersionInfo fvi = FileVersionInfo.GetVersionInfo(dllFilePath);
            this.tbVersion.Text = fvi.ProductVersion;

            ConfigureHyperlink(
                hlRami,
                "mailto:rami.abughazaleh@gmail.com");

            ConfigureHyperlink(
                hlMathias,
                "mailto:mathias@taschenorakel.de");

            ConfigureHyperlink(
                hlCodeplex,
                "http://nantmenu.codeplex.com");

            ConfigureHyperlink(
                hlLicense,
                System.IO.Path.Combine(appPath, "License.rtf"));

            ConfigureHyperlink(
                hlHelp,
                System.IO.Path.Combine(appPath, "NAntMenu.chm"));

            ConfigureHyperlink(
                hlDonate,
                "https://www.paypal.com/cgi-bin/webscr?cmd=_xclick&business=rami.abughazaleh%40gmail%2ecom&item_name=NAntMenu&buyer_credit_promo_code=&buyer_credit_product_category=&buyer_credit_shipping_method=&buyer_credit_user_address_change=&no_shipping=0&no_note=1&tax=0&currency_code=USD&lc=DK&bn=PP%2dDonationsBF&charset=UTF%2d8");

            using (Stream iconStream = assembly.GetManifestResourceStream("NAntMenu.ShellContextMenu.images.nant.ico"))
            {
                using (System.Drawing.Icon icon = new System.Drawing.Icon(iconStream, 128, 128))
                {
                    using (System.Drawing.Bitmap bitmap = icon.ToBitmap())
                    {
                        MemoryStream memoryStream = new MemoryStream();
                        bitmap.Save(memoryStream, System.Drawing.Imaging.ImageFormat.Png);
                        memoryStream.Seek(0, SeekOrigin.Begin);
                        PngBitmapDecoder pbd = new PngBitmapDecoder(memoryStream,

                                                BitmapCreateOptions.None, BitmapCacheOption.Default);
                        imgIcon.Source = pbd.Frames[0];
                    }
                }
            }
        }

        private void ConfigureHyperlink(Hyperlink hl, string uri)
        {
            hl.NavigateUri = new Uri(uri);
            hl.ToolTip = uri;
            hl.Click += new RoutedEventHandler(Hyperlink_Click);
        }

        private void Hyperlink_Click(object sender, RoutedEventArgs e)
        {
            Process.Start((sender as Hyperlink).NavigateUri.ToString());
        }
    }
}
